# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rdl_msgs/RobotState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import nav_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class RobotState(genpy.Message):
  _md5sum = "e428bef3bb6c10e06ff688f2a66e767a"
  _type = "rdl_msgs/RobotState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
sensor_msgs/JointState joint_states
nav_msgs/Odometry root_body_odometry
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: nav_msgs/Odometry
# This represents an estimate of a position and velocity in free space.  
# The pose in this message should be specified in the coordinate frame given by header.frame_id.
# The twist in this message should be specified in the coordinate frame given by the child_frame_id
Header header
string child_frame_id
geometry_msgs/PoseWithCovariance pose
geometry_msgs/TwistWithCovariance twist

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/TwistWithCovariance
# This expresses velocity in free space with uncertainty.

Twist twist

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['joint_states','root_body_odometry']
  _slot_types = ['sensor_msgs/JointState','nav_msgs/Odometry']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       joint_states,root_body_odometry

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RobotState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.joint_states is None:
        self.joint_states = sensor_msgs.msg.JointState()
      if self.root_body_odometry is None:
        self.root_body_odometry = nav_msgs.msg.Odometry()
    else:
      self.joint_states = sensor_msgs.msg.JointState()
      self.root_body_odometry = nav_msgs.msg.Odometry()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_states.header.seq, _x.joint_states.header.stamp.secs, _x.joint_states.header.stamp.nsecs))
      _x = self.joint_states.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_states.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_states.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_states.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_states.position))
      length = len(self.joint_states.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_states.velocity))
      length = len(self.joint_states.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_states.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.root_body_odometry.header.seq, _x.root_body_odometry.header.stamp.secs, _x.root_body_odometry.header.stamp.nsecs))
      _x = self.root_body_odometry.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.root_body_odometry.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.root_body_odometry.pose.pose.position.x, _x.root_body_odometry.pose.pose.position.y, _x.root_body_odometry.pose.pose.position.z, _x.root_body_odometry.pose.pose.orientation.x, _x.root_body_odometry.pose.pose.orientation.y, _x.root_body_odometry.pose.pose.orientation.z, _x.root_body_odometry.pose.pose.orientation.w))
      buff.write(_get_struct_36d().pack(*self.root_body_odometry.pose.covariance))
      _x = self
      buff.write(_get_struct_6d().pack(_x.root_body_odometry.twist.twist.linear.x, _x.root_body_odometry.twist.twist.linear.y, _x.root_body_odometry.twist.twist.linear.z, _x.root_body_odometry.twist.twist.angular.x, _x.root_body_odometry.twist.twist.angular.y, _x.root_body_odometry.twist.twist.angular.z))
      buff.write(_get_struct_36d().pack(*self.root_body_odometry.twist.covariance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.joint_states is None:
        self.joint_states = sensor_msgs.msg.JointState()
      if self.root_body_odometry is None:
        self.root_body_odometry = nav_msgs.msg.Odometry()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.joint_states.header.seq, _x.joint_states.header.stamp.secs, _x.joint_states.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_states.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_states.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_states.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_states.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.effort = s.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.root_body_odometry.header.seq, _x.root_body_odometry.header.stamp.secs, _x.root_body_odometry.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.root_body_odometry.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.root_body_odometry.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.root_body_odometry.child_frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.root_body_odometry.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.root_body_odometry.pose.pose.position.x, _x.root_body_odometry.pose.pose.position.y, _x.root_body_odometry.pose.pose.position.z, _x.root_body_odometry.pose.pose.orientation.x, _x.root_body_odometry.pose.pose.orientation.y, _x.root_body_odometry.pose.pose.orientation.z, _x.root_body_odometry.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 288
      self.root_body_odometry.pose.covariance = _get_struct_36d().unpack(str[start:end])
      _x = self
      start = end
      end += 48
      (_x.root_body_odometry.twist.twist.linear.x, _x.root_body_odometry.twist.twist.linear.y, _x.root_body_odometry.twist.twist.linear.z, _x.root_body_odometry.twist.twist.angular.x, _x.root_body_odometry.twist.twist.angular.y, _x.root_body_odometry.twist.twist.angular.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 288
      self.root_body_odometry.twist.covariance = _get_struct_36d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_states.header.seq, _x.joint_states.header.stamp.secs, _x.joint_states.header.stamp.nsecs))
      _x = self.joint_states.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_states.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_states.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_states.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_states.position.tostring())
      length = len(self.joint_states.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_states.velocity.tostring())
      length = len(self.joint_states.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_states.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.root_body_odometry.header.seq, _x.root_body_odometry.header.stamp.secs, _x.root_body_odometry.header.stamp.nsecs))
      _x = self.root_body_odometry.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.root_body_odometry.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.root_body_odometry.pose.pose.position.x, _x.root_body_odometry.pose.pose.position.y, _x.root_body_odometry.pose.pose.position.z, _x.root_body_odometry.pose.pose.orientation.x, _x.root_body_odometry.pose.pose.orientation.y, _x.root_body_odometry.pose.pose.orientation.z, _x.root_body_odometry.pose.pose.orientation.w))
      buff.write(self.root_body_odometry.pose.covariance.tostring())
      _x = self
      buff.write(_get_struct_6d().pack(_x.root_body_odometry.twist.twist.linear.x, _x.root_body_odometry.twist.twist.linear.y, _x.root_body_odometry.twist.twist.linear.z, _x.root_body_odometry.twist.twist.angular.x, _x.root_body_odometry.twist.twist.angular.y, _x.root_body_odometry.twist.twist.angular.z))
      buff.write(self.root_body_odometry.twist.covariance.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.joint_states is None:
        self.joint_states = sensor_msgs.msg.JointState()
      if self.root_body_odometry is None:
        self.root_body_odometry = nav_msgs.msg.Odometry()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.joint_states.header.seq, _x.joint_states.header.stamp.secs, _x.joint_states.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_states.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_states.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_states.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_states.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_states.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.root_body_odometry.header.seq, _x.root_body_odometry.header.stamp.secs, _x.root_body_odometry.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.root_body_odometry.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.root_body_odometry.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.root_body_odometry.child_frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.root_body_odometry.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.root_body_odometry.pose.pose.position.x, _x.root_body_odometry.pose.pose.position.y, _x.root_body_odometry.pose.pose.position.z, _x.root_body_odometry.pose.pose.orientation.x, _x.root_body_odometry.pose.pose.orientation.y, _x.root_body_odometry.pose.pose.orientation.z, _x.root_body_odometry.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 288
      self.root_body_odometry.pose.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      _x = self
      start = end
      end += 48
      (_x.root_body_odometry.twist.twist.linear.x, _x.root_body_odometry.twist.twist.linear.y, _x.root_body_odometry.twist.twist.linear.z, _x.root_body_odometry.twist.twist.angular.x, _x.root_body_odometry.twist.twist.angular.y, _x.root_body_odometry.twist.twist.angular.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 288
      self.root_body_odometry.twist.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_36d = None
def _get_struct_36d():
    global _struct_36d
    if _struct_36d is None:
        _struct_36d = struct.Struct("<36d")
    return _struct_36d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
