# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rdl_msgs/ChangeOrientationFrameRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ChangeOrientationFrameRequest(genpy.Message):
  _md5sum = "3efa522c535c66288ba34f8d2186c703"
  _type = "rdl_msgs/ChangeOrientationFrameRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The report will be an empty string if success=true successful

geometry_msgs/QuaternionStamped orientation_in
string new_reference_frame

================================================================================
MSG: geometry_msgs/QuaternionStamped
# This represents an orientation with reference coordinate frame and timestamp.

Header header
Quaternion quaternion

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['orientation_in','new_reference_frame']
  _slot_types = ['geometry_msgs/QuaternionStamped','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       orientation_in,new_reference_frame

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ChangeOrientationFrameRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.orientation_in is None:
        self.orientation_in = geometry_msgs.msg.QuaternionStamped()
      if self.new_reference_frame is None:
        self.new_reference_frame = ''
    else:
      self.orientation_in = geometry_msgs.msg.QuaternionStamped()
      self.new_reference_frame = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.orientation_in.header.seq, _x.orientation_in.header.stamp.secs, _x.orientation_in.header.stamp.nsecs))
      _x = self.orientation_in.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4d().pack(_x.orientation_in.quaternion.x, _x.orientation_in.quaternion.y, _x.orientation_in.quaternion.z, _x.orientation_in.quaternion.w))
      _x = self.new_reference_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.orientation_in is None:
        self.orientation_in = geometry_msgs.msg.QuaternionStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.orientation_in.header.seq, _x.orientation_in.header.stamp.secs, _x.orientation_in.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_in.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.orientation_in.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_in.quaternion.x, _x.orientation_in.quaternion.y, _x.orientation_in.quaternion.z, _x.orientation_in.quaternion.w,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.new_reference_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.new_reference_frame = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.orientation_in.header.seq, _x.orientation_in.header.stamp.secs, _x.orientation_in.header.stamp.nsecs))
      _x = self.orientation_in.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4d().pack(_x.orientation_in.quaternion.x, _x.orientation_in.quaternion.y, _x.orientation_in.quaternion.z, _x.orientation_in.quaternion.w))
      _x = self.new_reference_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.orientation_in is None:
        self.orientation_in = geometry_msgs.msg.QuaternionStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.orientation_in.header.seq, _x.orientation_in.header.stamp.secs, _x.orientation_in.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_in.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.orientation_in.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_in.quaternion.x, _x.orientation_in.quaternion.y, _x.orientation_in.quaternion.z, _x.orientation_in.quaternion.w,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.new_reference_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.new_reference_frame = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rdl_msgs/ChangeOrientationFrameResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ChangeOrientationFrameResponse(genpy.Message):
  _md5sum = "7cf610256a75b8a0d8b9a0b17fab492e"
  _type = "rdl_msgs/ChangeOrientationFrameResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool success
string report
geometry_msgs/QuaternionStamped orientation_out

================================================================================
MSG: geometry_msgs/QuaternionStamped
# This represents an orientation with reference coordinate frame and timestamp.

Header header
Quaternion quaternion

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['success','report','orientation_out']
  _slot_types = ['bool','string','geometry_msgs/QuaternionStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success,report,orientation_out

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ChangeOrientationFrameResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.report is None:
        self.report = ''
      if self.orientation_out is None:
        self.orientation_out = geometry_msgs.msg.QuaternionStamped()
    else:
      self.success = False
      self.report = ''
      self.orientation_out = geometry_msgs.msg.QuaternionStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.report
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.orientation_out.header.seq, _x.orientation_out.header.stamp.secs, _x.orientation_out.header.stamp.nsecs))
      _x = self.orientation_out.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4d().pack(_x.orientation_out.quaternion.x, _x.orientation_out.quaternion.y, _x.orientation_out.quaternion.z, _x.orientation_out.quaternion.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.orientation_out is None:
        self.orientation_out = geometry_msgs.msg.QuaternionStamped()
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.report = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.report = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.orientation_out.header.seq, _x.orientation_out.header.stamp.secs, _x.orientation_out.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_out.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.orientation_out.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_out.quaternion.x, _x.orientation_out.quaternion.y, _x.orientation_out.quaternion.z, _x.orientation_out.quaternion.w,) = _get_struct_4d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.report
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.orientation_out.header.seq, _x.orientation_out.header.stamp.secs, _x.orientation_out.header.stamp.nsecs))
      _x = self.orientation_out.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4d().pack(_x.orientation_out.quaternion.x, _x.orientation_out.quaternion.y, _x.orientation_out.quaternion.z, _x.orientation_out.quaternion.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.orientation_out is None:
        self.orientation_out = geometry_msgs.msg.QuaternionStamped()
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.report = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.report = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.orientation_out.header.seq, _x.orientation_out.header.stamp.secs, _x.orientation_out.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.orientation_out.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.orientation_out.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.orientation_out.quaternion.x, _x.orientation_out.quaternion.y, _x.orientation_out.quaternion.z, _x.orientation_out.quaternion.w,) = _get_struct_4d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class ChangeOrientationFrame(object):
  _type          = 'rdl_msgs/ChangeOrientationFrame'
  _md5sum = '9eb43d4e8f7087fe490b05a30e8dd7d9'
  _request_class  = ChangeOrientationFrameRequest
  _response_class = ChangeOrientationFrameResponse
