# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rdl_msgs/ChangeWrenchFrameRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ChangeWrenchFrameRequest(genpy.Message):
  _md5sum = "3d5ac79bb7e416754dd16de00ce780aa"
  _type = "rdl_msgs/ChangeWrenchFrameRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Change the reference frame a wrench is expressed in. The report will be an empty string if success=true
# successful

geometry_msgs/WrenchStamped wrench_in
string new_reference_frame

================================================================================
MSG: geometry_msgs/WrenchStamped
# A wrench with reference coordinate frame and timestamp
Header header
Wrench wrench

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['wrench_in','new_reference_frame']
  _slot_types = ['geometry_msgs/WrenchStamped','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       wrench_in,new_reference_frame

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ChangeWrenchFrameRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.wrench_in is None:
        self.wrench_in = geometry_msgs.msg.WrenchStamped()
      if self.new_reference_frame is None:
        self.new_reference_frame = ''
    else:
      self.wrench_in = geometry_msgs.msg.WrenchStamped()
      self.new_reference_frame = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.wrench_in.header.seq, _x.wrench_in.header.stamp.secs, _x.wrench_in.header.stamp.nsecs))
      _x = self.wrench_in.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.wrench_in.wrench.force.x, _x.wrench_in.wrench.force.y, _x.wrench_in.wrench.force.z, _x.wrench_in.wrench.torque.x, _x.wrench_in.wrench.torque.y, _x.wrench_in.wrench.torque.z))
      _x = self.new_reference_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.wrench_in is None:
        self.wrench_in = geometry_msgs.msg.WrenchStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.wrench_in.header.seq, _x.wrench_in.header.stamp.secs, _x.wrench_in.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wrench_in.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wrench_in.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.wrench_in.wrench.force.x, _x.wrench_in.wrench.force.y, _x.wrench_in.wrench.force.z, _x.wrench_in.wrench.torque.x, _x.wrench_in.wrench.torque.y, _x.wrench_in.wrench.torque.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.new_reference_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.new_reference_frame = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.wrench_in.header.seq, _x.wrench_in.header.stamp.secs, _x.wrench_in.header.stamp.nsecs))
      _x = self.wrench_in.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.wrench_in.wrench.force.x, _x.wrench_in.wrench.force.y, _x.wrench_in.wrench.force.z, _x.wrench_in.wrench.torque.x, _x.wrench_in.wrench.torque.y, _x.wrench_in.wrench.torque.z))
      _x = self.new_reference_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.wrench_in is None:
        self.wrench_in = geometry_msgs.msg.WrenchStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.wrench_in.header.seq, _x.wrench_in.header.stamp.secs, _x.wrench_in.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wrench_in.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wrench_in.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.wrench_in.wrench.force.x, _x.wrench_in.wrench.force.y, _x.wrench_in.wrench.force.z, _x.wrench_in.wrench.torque.x, _x.wrench_in.wrench.torque.y, _x.wrench_in.wrench.torque.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.new_reference_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.new_reference_frame = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rdl_msgs/ChangeWrenchFrameResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ChangeWrenchFrameResponse(genpy.Message):
  _md5sum = "5241d576c6232dc4b6603b1a0772d2f6"
  _type = "rdl_msgs/ChangeWrenchFrameResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool success
string report
geometry_msgs/WrenchStamped wrench_out

================================================================================
MSG: geometry_msgs/WrenchStamped
# A wrench with reference coordinate frame and timestamp
Header header
Wrench wrench

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['success','report','wrench_out']
  _slot_types = ['bool','string','geometry_msgs/WrenchStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success,report,wrench_out

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ChangeWrenchFrameResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.report is None:
        self.report = ''
      if self.wrench_out is None:
        self.wrench_out = geometry_msgs.msg.WrenchStamped()
    else:
      self.success = False
      self.report = ''
      self.wrench_out = geometry_msgs.msg.WrenchStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.report
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.wrench_out.header.seq, _x.wrench_out.header.stamp.secs, _x.wrench_out.header.stamp.nsecs))
      _x = self.wrench_out.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.wrench_out.wrench.force.x, _x.wrench_out.wrench.force.y, _x.wrench_out.wrench.force.z, _x.wrench_out.wrench.torque.x, _x.wrench_out.wrench.torque.y, _x.wrench_out.wrench.torque.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.wrench_out is None:
        self.wrench_out = geometry_msgs.msg.WrenchStamped()
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.report = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.report = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.wrench_out.header.seq, _x.wrench_out.header.stamp.secs, _x.wrench_out.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wrench_out.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wrench_out.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.wrench_out.wrench.force.x, _x.wrench_out.wrench.force.y, _x.wrench_out.wrench.force.z, _x.wrench_out.wrench.torque.x, _x.wrench_out.wrench.torque.y, _x.wrench_out.wrench.torque.z,) = _get_struct_6d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.report
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.wrench_out.header.seq, _x.wrench_out.header.stamp.secs, _x.wrench_out.header.stamp.nsecs))
      _x = self.wrench_out.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.wrench_out.wrench.force.x, _x.wrench_out.wrench.force.y, _x.wrench_out.wrench.force.z, _x.wrench_out.wrench.torque.x, _x.wrench_out.wrench.torque.y, _x.wrench_out.wrench.torque.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.wrench_out is None:
        self.wrench_out = geometry_msgs.msg.WrenchStamped()
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.report = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.report = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.wrench_out.header.seq, _x.wrench_out.header.stamp.secs, _x.wrench_out.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.wrench_out.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.wrench_out.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.wrench_out.wrench.force.x, _x.wrench_out.wrench.force.y, _x.wrench_out.wrench.force.z, _x.wrench_out.wrench.torque.x, _x.wrench_out.wrench.torque.y, _x.wrench_out.wrench.torque.z,) = _get_struct_6d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class ChangeWrenchFrame(object):
  _type          = 'rdl_msgs/ChangeWrenchFrame'
  _md5sum = '2a7cb68e33cc5fb4494854627ef2d11c'
  _request_class  = ChangeWrenchFrameRequest
  _response_class = ChangeWrenchFrameResponse
