// Auto-generated. Do not edit!

// (in-package rdl_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class ChangePointArrayFrameRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.point_array_in = null;
      this.new_reference_frame = null;
    }
    else {
      if (initObj.hasOwnProperty('point_array_in')) {
        this.point_array_in = initObj.point_array_in
      }
      else {
        this.point_array_in = [];
      }
      if (initObj.hasOwnProperty('new_reference_frame')) {
        this.new_reference_frame = initObj.new_reference_frame
      }
      else {
        this.new_reference_frame = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangePointArrayFrameRequest
    // Serialize message field [point_array_in]
    // Serialize the length for message field [point_array_in]
    bufferOffset = _serializer.uint32(obj.point_array_in.length, buffer, bufferOffset);
    obj.point_array_in.forEach((val) => {
      bufferOffset = geometry_msgs.msg.PointStamped.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [new_reference_frame]
    bufferOffset = _arraySerializer.string(obj.new_reference_frame, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangePointArrayFrameRequest
    let len;
    let data = new ChangePointArrayFrameRequest(null);
    // Deserialize message field [point_array_in]
    // Deserialize array length for message field [point_array_in]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.point_array_in = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.point_array_in[i] = geometry_msgs.msg.PointStamped.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [new_reference_frame]
    data.new_reference_frame = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.point_array_in.forEach((val) => {
      length += geometry_msgs.msg.PointStamped.getMessageSize(val);
    });
    object.new_reference_frame.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangePointArrayFrameRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f8cce1b53f91d8438a01a43f0e01559c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Change the reference frame of points in an array of points. The report will be an empty string if success=true
    
    geometry_msgs/PointStamped[] point_array_in
    string[] new_reference_frame
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangePointArrayFrameRequest(null);
    if (msg.point_array_in !== undefined) {
      resolved.point_array_in = new Array(msg.point_array_in.length);
      for (let i = 0; i < resolved.point_array_in.length; ++i) {
        resolved.point_array_in[i] = geometry_msgs.msg.PointStamped.Resolve(msg.point_array_in[i]);
      }
    }
    else {
      resolved.point_array_in = []
    }

    if (msg.new_reference_frame !== undefined) {
      resolved.new_reference_frame = msg.new_reference_frame;
    }
    else {
      resolved.new_reference_frame = []
    }

    return resolved;
    }
};

class ChangePointArrayFrameResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.report = null;
      this.point_array_out = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('report')) {
        this.report = initObj.report
      }
      else {
        this.report = '';
      }
      if (initObj.hasOwnProperty('point_array_out')) {
        this.point_array_out = initObj.point_array_out
      }
      else {
        this.point_array_out = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangePointArrayFrameResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [report]
    bufferOffset = _serializer.string(obj.report, buffer, bufferOffset);
    // Serialize message field [point_array_out]
    // Serialize the length for message field [point_array_out]
    bufferOffset = _serializer.uint32(obj.point_array_out.length, buffer, bufferOffset);
    obj.point_array_out.forEach((val) => {
      bufferOffset = geometry_msgs.msg.PointStamped.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangePointArrayFrameResponse
    let len;
    let data = new ChangePointArrayFrameResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [report]
    data.report = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [point_array_out]
    // Deserialize array length for message field [point_array_out]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.point_array_out = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.point_array_out[i] = geometry_msgs.msg.PointStamped.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.report.length;
    object.point_array_out.forEach((val) => {
      length += geometry_msgs.msg.PointStamped.getMessageSize(val);
    });
    return length + 9;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangePointArrayFrameResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '633644e976907a6ff9f355d4166bb6fd';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string report
    geometry_msgs/PointStamped[] point_array_out
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangePointArrayFrameResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.report !== undefined) {
      resolved.report = msg.report;
    }
    else {
      resolved.report = ''
    }

    if (msg.point_array_out !== undefined) {
      resolved.point_array_out = new Array(msg.point_array_out.length);
      for (let i = 0; i < resolved.point_array_out.length; ++i) {
        resolved.point_array_out[i] = geometry_msgs.msg.PointStamped.Resolve(msg.point_array_out[i]);
      }
    }
    else {
      resolved.point_array_out = []
    }

    return resolved;
    }
};

module.exports = {
  Request: ChangePointArrayFrameRequest,
  Response: ChangePointArrayFrameResponse,
  md5sum() { return '90df21ba2d9e07bec31bd67f00e80b34'; },
  datatype() { return 'rdl_msgs/ChangePointArrayFrame'; }
};
