// Auto-generated. Do not edit!

// (in-package rdl_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class ChangeTwistArrayFrameRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.twist_array_in = null;
      this.new_reference_frame = null;
    }
    else {
      if (initObj.hasOwnProperty('twist_array_in')) {
        this.twist_array_in = initObj.twist_array_in
      }
      else {
        this.twist_array_in = [];
      }
      if (initObj.hasOwnProperty('new_reference_frame')) {
        this.new_reference_frame = initObj.new_reference_frame
      }
      else {
        this.new_reference_frame = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeTwistArrayFrameRequest
    // Serialize message field [twist_array_in]
    // Serialize the length for message field [twist_array_in]
    bufferOffset = _serializer.uint32(obj.twist_array_in.length, buffer, bufferOffset);
    obj.twist_array_in.forEach((val) => {
      bufferOffset = geometry_msgs.msg.TwistStamped.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [new_reference_frame]
    bufferOffset = _arraySerializer.string(obj.new_reference_frame, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeTwistArrayFrameRequest
    let len;
    let data = new ChangeTwistArrayFrameRequest(null);
    // Deserialize message field [twist_array_in]
    // Deserialize array length for message field [twist_array_in]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.twist_array_in = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.twist_array_in[i] = geometry_msgs.msg.TwistStamped.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [new_reference_frame]
    data.new_reference_frame = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.twist_array_in.forEach((val) => {
      length += geometry_msgs.msg.TwistStamped.getMessageSize(val);
    });
    object.new_reference_frame.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeTwistArrayFrameRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '52263da4a9f150b42cdf2b098ff01a88';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Change the reference frame of twists in an array of wrenches. The report will be an empty string if success=true
    
    geometry_msgs/TwistStamped[] twist_array_in
    string[] new_reference_frame
    
    ================================================================================
    MSG: geometry_msgs/TwistStamped
    # A twist with reference coordinate frame and timestamp
    Header header
    Twist twist
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeTwistArrayFrameRequest(null);
    if (msg.twist_array_in !== undefined) {
      resolved.twist_array_in = new Array(msg.twist_array_in.length);
      for (let i = 0; i < resolved.twist_array_in.length; ++i) {
        resolved.twist_array_in[i] = geometry_msgs.msg.TwistStamped.Resolve(msg.twist_array_in[i]);
      }
    }
    else {
      resolved.twist_array_in = []
    }

    if (msg.new_reference_frame !== undefined) {
      resolved.new_reference_frame = msg.new_reference_frame;
    }
    else {
      resolved.new_reference_frame = []
    }

    return resolved;
    }
};

class ChangeTwistArrayFrameResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.report = null;
      this.twist_array_out = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('report')) {
        this.report = initObj.report
      }
      else {
        this.report = '';
      }
      if (initObj.hasOwnProperty('twist_array_out')) {
        this.twist_array_out = initObj.twist_array_out
      }
      else {
        this.twist_array_out = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeTwistArrayFrameResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [report]
    bufferOffset = _serializer.string(obj.report, buffer, bufferOffset);
    // Serialize message field [twist_array_out]
    // Serialize the length for message field [twist_array_out]
    bufferOffset = _serializer.uint32(obj.twist_array_out.length, buffer, bufferOffset);
    obj.twist_array_out.forEach((val) => {
      bufferOffset = geometry_msgs.msg.TwistStamped.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeTwistArrayFrameResponse
    let len;
    let data = new ChangeTwistArrayFrameResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [report]
    data.report = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [twist_array_out]
    // Deserialize array length for message field [twist_array_out]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.twist_array_out = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.twist_array_out[i] = geometry_msgs.msg.TwistStamped.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.report.length;
    object.twist_array_out.forEach((val) => {
      length += geometry_msgs.msg.TwistStamped.getMessageSize(val);
    });
    return length + 9;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeTwistArrayFrameResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a1d1d3013d8a43e66f366de320ca2e01';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string report
    geometry_msgs/TwistStamped[] twist_array_out
    
    ================================================================================
    MSG: geometry_msgs/TwistStamped
    # A twist with reference coordinate frame and timestamp
    Header header
    Twist twist
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeTwistArrayFrameResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.report !== undefined) {
      resolved.report = msg.report;
    }
    else {
      resolved.report = ''
    }

    if (msg.twist_array_out !== undefined) {
      resolved.twist_array_out = new Array(msg.twist_array_out.length);
      for (let i = 0; i < resolved.twist_array_out.length; ++i) {
        resolved.twist_array_out[i] = geometry_msgs.msg.TwistStamped.Resolve(msg.twist_array_out[i]);
      }
    }
    else {
      resolved.twist_array_out = []
    }

    return resolved;
    }
};

module.exports = {
  Request: ChangeTwistArrayFrameRequest,
  Response: ChangeTwistArrayFrameResponse,
  md5sum() { return 'e0f037ef4468f9463948abac1286c754'; },
  datatype() { return 'rdl_msgs/ChangeTwistArrayFrame'; }
};
