// Auto-generated. Do not edit!

// (in-package rdl_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class ChangeTwistFrameRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.twist_in = null;
      this.new_reference_frame = null;
    }
    else {
      if (initObj.hasOwnProperty('twist_in')) {
        this.twist_in = initObj.twist_in
      }
      else {
        this.twist_in = new geometry_msgs.msg.TwistStamped();
      }
      if (initObj.hasOwnProperty('new_reference_frame')) {
        this.new_reference_frame = initObj.new_reference_frame
      }
      else {
        this.new_reference_frame = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeTwistFrameRequest
    // Serialize message field [twist_in]
    bufferOffset = geometry_msgs.msg.TwistStamped.serialize(obj.twist_in, buffer, bufferOffset);
    // Serialize message field [new_reference_frame]
    bufferOffset = _serializer.string(obj.new_reference_frame, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeTwistFrameRequest
    let len;
    let data = new ChangeTwistFrameRequest(null);
    // Deserialize message field [twist_in]
    data.twist_in = geometry_msgs.msg.TwistStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [new_reference_frame]
    data.new_reference_frame = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.TwistStamped.getMessageSize(object.twist_in);
    length += object.new_reference_frame.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeTwistFrameRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '23188f3db2331fd142aa186762a12466';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Change the reference frame a twist is expressed in. The report will be an empty string if success=true
    # successful
    
    geometry_msgs/TwistStamped twist_in
    string new_reference_frame
    
    ================================================================================
    MSG: geometry_msgs/TwistStamped
    # A twist with reference coordinate frame and timestamp
    Header header
    Twist twist
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeTwistFrameRequest(null);
    if (msg.twist_in !== undefined) {
      resolved.twist_in = geometry_msgs.msg.TwistStamped.Resolve(msg.twist_in)
    }
    else {
      resolved.twist_in = new geometry_msgs.msg.TwistStamped()
    }

    if (msg.new_reference_frame !== undefined) {
      resolved.new_reference_frame = msg.new_reference_frame;
    }
    else {
      resolved.new_reference_frame = ''
    }

    return resolved;
    }
};

class ChangeTwistFrameResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.report = null;
      this.twist_out = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('report')) {
        this.report = initObj.report
      }
      else {
        this.report = '';
      }
      if (initObj.hasOwnProperty('twist_out')) {
        this.twist_out = initObj.twist_out
      }
      else {
        this.twist_out = new geometry_msgs.msg.TwistStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeTwistFrameResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [report]
    bufferOffset = _serializer.string(obj.report, buffer, bufferOffset);
    // Serialize message field [twist_out]
    bufferOffset = geometry_msgs.msg.TwistStamped.serialize(obj.twist_out, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeTwistFrameResponse
    let len;
    let data = new ChangeTwistFrameResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [report]
    data.report = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [twist_out]
    data.twist_out = geometry_msgs.msg.TwistStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.report.length;
    length += geometry_msgs.msg.TwistStamped.getMessageSize(object.twist_out);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeTwistFrameResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd2a38532e61fd1b6c0ab0328b89bab7b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string report
    geometry_msgs/TwistStamped twist_out
    
    ================================================================================
    MSG: geometry_msgs/TwistStamped
    # A twist with reference coordinate frame and timestamp
    Header header
    Twist twist
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeTwistFrameResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.report !== undefined) {
      resolved.report = msg.report;
    }
    else {
      resolved.report = ''
    }

    if (msg.twist_out !== undefined) {
      resolved.twist_out = geometry_msgs.msg.TwistStamped.Resolve(msg.twist_out)
    }
    else {
      resolved.twist_out = new geometry_msgs.msg.TwistStamped()
    }

    return resolved;
    }
};

module.exports = {
  Request: ChangeTwistFrameRequest,
  Response: ChangeTwistFrameResponse,
  md5sum() { return '8c606556e1db562ffded4f804c322bc0'; },
  datatype() { return 'rdl_msgs/ChangeTwistFrame'; }
};
