// Auto-generated. Do not edit!

// (in-package rdl_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class ChangeWrenchFrameRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.wrench_in = null;
      this.new_reference_frame = null;
    }
    else {
      if (initObj.hasOwnProperty('wrench_in')) {
        this.wrench_in = initObj.wrench_in
      }
      else {
        this.wrench_in = new geometry_msgs.msg.WrenchStamped();
      }
      if (initObj.hasOwnProperty('new_reference_frame')) {
        this.new_reference_frame = initObj.new_reference_frame
      }
      else {
        this.new_reference_frame = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeWrenchFrameRequest
    // Serialize message field [wrench_in]
    bufferOffset = geometry_msgs.msg.WrenchStamped.serialize(obj.wrench_in, buffer, bufferOffset);
    // Serialize message field [new_reference_frame]
    bufferOffset = _serializer.string(obj.new_reference_frame, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeWrenchFrameRequest
    let len;
    let data = new ChangeWrenchFrameRequest(null);
    // Deserialize message field [wrench_in]
    data.wrench_in = geometry_msgs.msg.WrenchStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [new_reference_frame]
    data.new_reference_frame = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.WrenchStamped.getMessageSize(object.wrench_in);
    length += object.new_reference_frame.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeWrenchFrameRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3d5ac79bb7e416754dd16de00ce780aa';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Change the reference frame a wrench is expressed in. The report will be an empty string if success=true
    # successful
    
    geometry_msgs/WrenchStamped wrench_in
    string new_reference_frame
    
    ================================================================================
    MSG: geometry_msgs/WrenchStamped
    # A wrench with reference coordinate frame and timestamp
    Header header
    Wrench wrench
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Wrench
    # This represents force in free space, separated into
    # its linear and angular parts.
    Vector3  force
    Vector3  torque
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeWrenchFrameRequest(null);
    if (msg.wrench_in !== undefined) {
      resolved.wrench_in = geometry_msgs.msg.WrenchStamped.Resolve(msg.wrench_in)
    }
    else {
      resolved.wrench_in = new geometry_msgs.msg.WrenchStamped()
    }

    if (msg.new_reference_frame !== undefined) {
      resolved.new_reference_frame = msg.new_reference_frame;
    }
    else {
      resolved.new_reference_frame = ''
    }

    return resolved;
    }
};

class ChangeWrenchFrameResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.report = null;
      this.wrench_out = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('report')) {
        this.report = initObj.report
      }
      else {
        this.report = '';
      }
      if (initObj.hasOwnProperty('wrench_out')) {
        this.wrench_out = initObj.wrench_out
      }
      else {
        this.wrench_out = new geometry_msgs.msg.WrenchStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ChangeWrenchFrameResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [report]
    bufferOffset = _serializer.string(obj.report, buffer, bufferOffset);
    // Serialize message field [wrench_out]
    bufferOffset = geometry_msgs.msg.WrenchStamped.serialize(obj.wrench_out, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ChangeWrenchFrameResponse
    let len;
    let data = new ChangeWrenchFrameResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [report]
    data.report = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [wrench_out]
    data.wrench_out = geometry_msgs.msg.WrenchStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.report.length;
    length += geometry_msgs.msg.WrenchStamped.getMessageSize(object.wrench_out);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/ChangeWrenchFrameResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5241d576c6232dc4b6603b1a0772d2f6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string report
    geometry_msgs/WrenchStamped wrench_out
    
    ================================================================================
    MSG: geometry_msgs/WrenchStamped
    # A wrench with reference coordinate frame and timestamp
    Header header
    Wrench wrench
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Wrench
    # This represents force in free space, separated into
    # its linear and angular parts.
    Vector3  force
    Vector3  torque
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ChangeWrenchFrameResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.report !== undefined) {
      resolved.report = msg.report;
    }
    else {
      resolved.report = ''
    }

    if (msg.wrench_out !== undefined) {
      resolved.wrench_out = geometry_msgs.msg.WrenchStamped.Resolve(msg.wrench_out)
    }
    else {
      resolved.wrench_out = new geometry_msgs.msg.WrenchStamped()
    }

    return resolved;
    }
};

module.exports = {
  Request: ChangeWrenchFrameRequest,
  Response: ChangeWrenchFrameResponse,
  md5sum() { return '2a7cb68e33cc5fb4494854627ef2d11c'; },
  datatype() { return 'rdl_msgs/ChangeWrenchFrame'; }
};
