// Auto-generated. Do not edit!

// (in-package rdl_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class GetTwistRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.body_frame = null;
      this.base_frame = null;
      this.expressed_in_frame = null;
    }
    else {
      if (initObj.hasOwnProperty('body_frame')) {
        this.body_frame = initObj.body_frame
      }
      else {
        this.body_frame = '';
      }
      if (initObj.hasOwnProperty('base_frame')) {
        this.base_frame = initObj.base_frame
      }
      else {
        this.base_frame = '';
      }
      if (initObj.hasOwnProperty('expressed_in_frame')) {
        this.expressed_in_frame = initObj.expressed_in_frame
      }
      else {
        this.expressed_in_frame = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetTwistRequest
    // Serialize message field [body_frame]
    bufferOffset = _serializer.string(obj.body_frame, buffer, bufferOffset);
    // Serialize message field [base_frame]
    bufferOffset = _serializer.string(obj.base_frame, buffer, bufferOffset);
    // Serialize message field [expressed_in_frame]
    bufferOffset = _serializer.string(obj.expressed_in_frame, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetTwistRequest
    let len;
    let data = new GetTwistRequest(null);
    // Deserialize message field [body_frame]
    data.body_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [base_frame]
    data.base_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [expressed_in_frame]
    data.expressed_in_frame = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.body_frame.length;
    length += object.base_frame.length;
    length += object.expressed_in_frame.length;
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/GetTwistRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ad91ef60cc95eeef2202c80ec6eb707d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    # body_frame: The frame of interest
    # base_frame: The twist will represent the motion of body_frame relative to base_frame
    # expressed_in_frame: The resulting twist will be expressed in this reference frame
    
    string body_frame
    string base_frame
    string expressed_in_frame
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetTwistRequest(null);
    if (msg.body_frame !== undefined) {
      resolved.body_frame = msg.body_frame;
    }
    else {
      resolved.body_frame = ''
    }

    if (msg.base_frame !== undefined) {
      resolved.base_frame = msg.base_frame;
    }
    else {
      resolved.base_frame = ''
    }

    if (msg.expressed_in_frame !== undefined) {
      resolved.expressed_in_frame = msg.expressed_in_frame;
    }
    else {
      resolved.expressed_in_frame = ''
    }

    return resolved;
    }
};

class GetTwistResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.report = null;
      this.twist_out = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('report')) {
        this.report = initObj.report
      }
      else {
        this.report = '';
      }
      if (initObj.hasOwnProperty('twist_out')) {
        this.twist_out = initObj.twist_out
      }
      else {
        this.twist_out = new geometry_msgs.msg.TwistStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetTwistResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [report]
    bufferOffset = _serializer.string(obj.report, buffer, bufferOffset);
    // Serialize message field [twist_out]
    bufferOffset = geometry_msgs.msg.TwistStamped.serialize(obj.twist_out, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetTwistResponse
    let len;
    let data = new GetTwistResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [report]
    data.report = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [twist_out]
    data.twist_out = geometry_msgs.msg.TwistStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.report.length;
    length += geometry_msgs.msg.TwistStamped.getMessageSize(object.twist_out);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rdl_msgs/GetTwistResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd2a38532e61fd1b6c0ab0328b89bab7b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string report
    geometry_msgs/TwistStamped twist_out
    
    ================================================================================
    MSG: geometry_msgs/TwistStamped
    # A twist with reference coordinate frame and timestamp
    Header header
    Twist twist
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetTwistResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.report !== undefined) {
      resolved.report = msg.report;
    }
    else {
      resolved.report = ''
    }

    if (msg.twist_out !== undefined) {
      resolved.twist_out = geometry_msgs.msg.TwistStamped.Resolve(msg.twist_out)
    }
    else {
      resolved.twist_out = new geometry_msgs.msg.TwistStamped()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetTwistRequest,
  Response: GetTwistResponse,
  md5sum() { return '1c41a50c639181702393edb0d09bdccd'; },
  datatype() { return 'rdl_msgs/GetTwist'; }
};
